<?php

/*
  Copyright (C) 2008 www.ads-ez.com

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License as
  published by the Free Software Foundation; either version 3 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if (!class_exists("ezExtras")) {
  define('EZSIZE', '300x250');

  class ezExtras { // static functions

    public static function splitSize($size) {
      $x = strpos($size, 'x');
      $w = substr($size, 0, $x);
      $h = substr($size, $x + 1);
      $needle = array($w, $h);
      return $needle;
    }

    public static function getMcAd($key = EZSIZE) {
      $mcAds = ezNS::$defaults['ads'][$key];
      if (empty($mcAds)) {
        $mcAds = ezNS::$defaults['ads'][EZSIZE];
      }
      if (is_array($mcAds)) {
        $picked = $mcAds[array_rand($mcAds)];
      }
      else {
        $picked = $mcAds;
      }
      $ret = htmlspecialchars_decode($picked);
      return $ret;
    }

    public static function filterAds($text, $w, $h, $p) {
      $banReason = '';
      $banReason = get_transient('ezAdsBanReason');
      if (empty($banReason)) {
        if (function_exists('gFilter')) {
          $gFilter = ezNS::$adminOptions['gFilter'];
          if (!empty($gFilter)) {
            if (($ezAdsContent = get_transient('ezAdsContent')) !== false) {
              $maxScore = ezNS::$adminOptions['maxScore'];
              $banReason = gFilter($ezAdsContent, ezNS::$defaults['banned'], $maxScore);
              $ipString = ezNS::$adminOptions['bannedIPs'];
              $bannedIPs = explode(',', $ipString);
              array_walk($bannedIPs, create_function('&$val', '$val = trim($val);'));
              $banReason .= killGAds($bannedIPs);
            }
          }
          $timeout = 6;
          set_transient('ezAdsBanReason', $banReason, $timeout);
        }
      }
      if (empty($banReason)) {
        return $text;
      }
      else {
        return '<div style="width:' . $w . 'px;height:' . $h . 'px;border:1px solid red;margin:10px;"><div style="padding:' . $p . 'px;text-align:center;font-family:arial;font-size:8pt;"><p>' . sprintf(__('Your ad here was suppressed by %s', 'easy-ads'), '</p><p><b><a href="http://buy.thulasidas.com/' . ezNS::$baseName . '" ') . 'title="' . __('The next generation advertising plugin for WordPress', 'easy-ads') . '" target="_blank">' . ezNS::$name . ezNS::$strPro . '</a></b>.</p><p>' . __('Reason:', 'easy-ads') . ' <i><span style="color:red">' . $banReason . '</span></i></p></div></div>';
      }
    }

    public static function handleDefaultText($ad, $key = EZSIZE) {
      $x = strpos($key, 'x');
      $w = substr($key, 0, $x) - 20;
      $h = substr($key, $x + 1) - 20;
      $p = (int) (min($w, $h) / 6);
      if (ezNS::$isPro) {
        $ret = self::filterAds($ad, $w, $h, $p);
      }
      else {
        $ret = $ad;
      }
      if ($ret == ezNS::$defaults['defaultText'] || strlen(trim($ret)) == 0) {
        if (ezNS::$isPro) {
          if (ezNS::$adminOptions['suppressBoxes']) {
            $ret = '';
          }
          else {
            $ret = '<div style="width:' . $w . 'px;height:' . $h . 'px;border:1px solid red;margin:10px;"><div style="padding:' . $p . 'px;text-align:center;font-family:arial;font-size:8pt;"><p>' . sprintf(__('Your ads will be inserted here by %s', 'easy-ads'), '</p><p><b><a href="http://buy.ads-ez.com/' . ezNS::$baseName . '"') . ' title="' . __('The next generation advertising plugin for WordPress', 'easy-ads') . '" target="_blank">' . ezNS::$name . ezNS::$strPro . '</a></b>.</p><p>' . __('Please go to the plugin admin page to set up your ad code.', 'easy-ads') . '</p></div></div>';
          }
        }
        else {
          $ret = self::getMcAd($key);
          ezNS::$mced = true;
        }
      }
      return $ret;
    }

    public static function decorateAd($ad) {
      return '<div class="easy-ads">' . $ad . "</div>\n";
    }

    public static function handleSharedSlot($mc, $ad, $matchSize = false) {
      if ($mc <= 0 || ezNS::$mced) {
        return $ad;
      }
      $ret = $ad;
      // 1.11 is the approx. solution to (p/s) in the eqn:
      // 3s = p + (1-p) p + (1-p)^2 p
      // s: share fraction, p: probability
      $mx = 111 * $mc;
      if ($mc < 100) {
        $rnd = mt_rand(0, 10000);
      }
      else {
        $rnd = 1;
      }
      if ($rnd < $mx) {
        if (!$matchSize) {
          $key = EZSIZE;
        }
        if (ereg("([0-9]{3}x[0-9]{2,3})", $ad, $regs)) {
          $key = $regs[1];
        }
        $ret = self::getMcAd($key);
        ezNS::$mced = true;
      }
      return self::decorateAd($ret);
    }

    public static function isGoogle($ad) {
      $isGoogle = strpos($ad, 'google_ad') !== FALSE;
      return $isGoogle;
    }

    public static function enforceGCount($ad) {
      $ret = $ad;
      $isGoogle = self::isGoogle($ad);
      if ($isGoogle && ezNS::$gCount++ >= 3) {
        $ret = self::handleDefaultText('');
      }
      return self::decorateAd($ret);
    }

    public static function findPara($content, $midpoint) {
      $para = '<p';
      $content = strtolower($content);  // not using stripos() for PHP4 compatibility
      $paraPosition = strpos($content, $para, $midpoint);
      if ($paraPosition === FALSE) {
        $para = '<br';
        $paraPosition = strpos($content, $para, $midpoint);
      }
      return $paraPosition;
    }

  }

}  //End: Class ezExtras
